#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "hash.h"

int compare_string(void* _s1, void* _s2) {
  return strcmp((char*)_s1, (char*)_s2);
}

int hash_string(void* _s) {
  char* s = (char *)_s;
  int i, r = 0;

  for (i = 0; s[i] != 0; i++) {
    r *= 10;
    r += s[i];
  }

  if (r < 0) r = -r;

  return r;
}

int main(int argc, char** argv)
{
  hash_table* ht;
  void *val;
  char buffer[256];
  int print_it;
  FILE *f;

  ht = make_hash_table(compare_string, hash_string);

  if (!strcmp(argv[1], "-")) {
    /* accept input from stdin and print it */
    f = stdin;
    print_it = 1;
  } else {
    /* read tree from a file and don't print */
    f = fopen(argv[1], "r");
    print_it = 0;
  }

  val = malloc(sizeof(int));

  while (fgets(buffer, 256, f)) {
    hash_set(ht, strdup(buffer), val);
  }
  if (f != stdin)
    fclose(f);

  printf("%d words\n", hash_count(ht));

  while (fgets(buffer, 256, stdin)) {
    val = hash_get(ht, buffer);
    if (val == NULL)
      printf("Not there\n");
    else
      printf("Value: %p\n", val);
  }

  if (print_it) {
    hash_iter* i;

    for (i = hash_iterate_new(ht);
         i != NULL;
         i = hash_iterate_next(ht, i)) {
      char* s = (char*)hash_iterate_key(ht, i);
      if (s != NULL)
        printf(" %s", s);
    }
  }

  return 0;
}
